diff -urNEBb binutils-2.14-orig/bfd/aout-amiga.c binutils-2.14/bfd/aout-amiga.c
--- binutils-2.14-orig/bfd/aout-amiga.c	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/bfd/aout-amiga.c	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,54 @@
+/* BFD backend for Amiga style a.out with flags set to 0
+   Copyright (C) 1990, 91, 92, 93, 1994 Free Software Foundation, Inc.
+   Written by Stephan Thesing.
+
+This file is part of BFD, the Binary File Descriptor library.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
+
+#define TARGETNAME "a.out-amiga"
+
+/* Do not "beautify" the CONCAT* macro args.  Traditional C will not
+   remove whitespace added here, and thus will fail to concatenate
+   the tokens.  */
+#define MY(OP) CONCAT2 (aout_amiga_,OP)
+
+#include "bfd.h"
+
+#define MY_exec_hdr_flags 0
+
+extern bfd_boolean
+amiga_final_link(bfd *,struct bfd_link_info *);
+#define MY_bfd_final_link amiga_final_link
+
+extern bfd_byte *
+get_relocated_section_contents(bfd *, struct bfd_link_info *,
+			       struct bfd_link_order *, bfd_byte *,
+			       bfd_boolean , asymbol **);
+#define MY_bfd_get_relocated_section_contents get_relocated_section_contents
+
+/* Include the usual a.out support.  */
+#include "aoutf1.h"
+
+/* Final link routine.  We need to use a call back to get the correct
+   offsets in the output file.  */
+
+bfd_boolean
+amiga_aout_bfd_final_link (abfd, info)
+     bfd *abfd;
+     struct bfd_link_info *info;
+{
+  return NAME(aout,final_link) (abfd, info, MY_final_link_callback);
+}
diff -urNEBb binutils-2.14-orig/bfd/aoutx.h binutils-2.14/bfd/aoutx.h
--- binutils-2.14-orig/bfd/aoutx.h	2003-03-31 19:13:24.000000000 +0200
+++ binutils-2.14/bfd/aoutx.h	2003-12-02 14:09:39.000000000 +0100
@@ -133,7 +133,8 @@
   PARAMS ((bfd *));
 static bfd_boolean translate_from_native_sym_flags
   PARAMS ((bfd *, aout_symbol_type *));
-static bfd_boolean translate_to_native_sym_flags
+/*Amiga hack - used in amigaos.c, must be global */
+/*static*/ bfd_boolean translate_to_native_sym_flags
   PARAMS ((bfd *, asymbol *, struct external_nlist *));
 static void adjust_o_magic
   PARAMS ((bfd *, struct internal_exec *));
@@ -1657,7 +1658,7 @@
 
 /* Set the fields of SYM_POINTER according to CACHE_PTR.  */
 
-static bfd_boolean
+/*static*/ bfd_boolean
 translate_to_native_sym_flags (abfd, cache_ptr, sym_pointer)
      bfd *abfd;
      asymbol *cache_ptr;
@@ -2065,12 +2066,31 @@
 
   PUT_WORD (abfd, g->address, natptr->r_address);
 
-  r_length = g->howto->size ;	/* Size as a power of two.  */
+  r_length = g->howto->size ;	/* Size as a power of two */
   r_pcrel  = (int) g->howto->pc_relative; /* Relative to PC?  */
+#if 1
+  /* FIXME! "#if 1" is the wrong way to select this Amiga specific code.
+   We can't just test for __amigaos__ defined either, since we may be
+   building a cross compiler and __amigaos__ is only defined if the
+   compiler we are using is targeted for the Amiga. */
+  /* Changed for cooperation with AMIGA backend */
+  /* This only applies, if aout flavour    191194 ST*/
   /* XXX This relies on relocs coming from a.out files.  */
+  if (bfd_asymbol_bfd(sym)->xvec->flavour==bfd_target_aout_flavour)
+    {
   r_baserel = (g->howto->type & 8) != 0;
   r_jmptable = (g->howto->type & 16) != 0;
   r_relative = (g->howto->type & 32) != 0;
+    }
+  else
+    {
+      r_baserel=r_jmptable=r_relative=0;
+    }
+#else
+  r_baserel = (g->howto->type & 8) != 0;
+  r_jmptable = (g->howto->type & 16) != 0;
+  r_relative = (g->howto->type & 32) != 0;
+#endif
 
 #if 0
   /* For a standard reloc, the addend is in the object file.  */
@@ -2369,8 +2389,12 @@
   /* Base relative relocs are always against the symbol table,
      regardless of the setting of r_extern.  r_extern just reflects
      whether the symbol the reloc is against is local or global.  */
+#if 0
+  /* FIXME! "#if 0" is the wrong way to disable this code.  See comment
+     earlier in file. */
   if (r_baserel)
     r_extern = 1;
+#endif
 
   if (r_extern && r_index > symcount)
     {
diff -urNEBb binutils-2.14-orig/bfd/bfd-in2.h binutils-2.14/bfd/bfd-in2.h
--- binutils-2.14-orig/bfd/bfd-in2.h	2003-05-03 17:06:56.000000000 +0200
+++ binutils-2.14/bfd/bfd-in2.h	2003-12-02 14:09:39.000000000 +0100
@@ -2484,6 +2484,10 @@
   BFD_RELOC_PPC_EMB_RELST_HA,
   BFD_RELOC_PPC_EMB_BIT_FLD,
   BFD_RELOC_PPC_EMB_RELSDA,
+  BFD_RELOC_PPC_MORPHOS_DREL,
+  BFD_RELOC_PPC_MORPHOS_DREL_LO,
+  BFD_RELOC_PPC_MORPHOS_DREL_HI,
+  BFD_RELOC_PPC_MORPHOS_DREL_HA,
   BFD_RELOC_PPC64_HIGHER,
   BFD_RELOC_PPC64_HIGHER_S,
   BFD_RELOC_PPC64_HIGHEST,
@@ -3806,6 +3810,7 @@
       struct cisco_core_struct *cisco_core_data;
       struct versados_data_struct *versados_data;
       struct netbsd_core_struct *netbsd_core_data;
+      struct amiga_data_struct *amiga_data;
       struct mach_o_data_struct *mach_o_data;
       struct mach_o_fat_data_struct *mach_o_fat_data;
       struct bfd_pef_data_struct *pef_data;
@@ -4069,6 +4074,7 @@
 enum bfd_flavour
 {
   bfd_target_unknown_flavour,
+  bfd_target_amiga_flavour,
   bfd_target_aout_flavour,
   bfd_target_coff_flavour,
   bfd_target_ecoff_flavour,
diff -urNEBb binutils-2.14-orig/bfd/bfd.c binutils-2.14/bfd/bfd.c
--- binutils-2.14-orig/bfd/bfd.c	2003-03-01 00:43:34.000000000 +0100
+++ binutils-2.14/bfd/bfd.c	2003-12-02 14:09:39.000000000 +0100
@@ -183,6 +183,7 @@
 .      struct cisco_core_struct *cisco_core_data;
 .      struct versados_data_struct *versados_data;
 .      struct netbsd_core_struct *netbsd_core_data;
+.      struct amiga_data_struct *amiga_data;
 .      struct mach_o_data_struct *mach_o_data;
 .      struct mach_o_fat_data_struct *mach_o_fat_data;
 .      struct bfd_pef_data_struct *pef_data;
diff -urNEBb binutils-2.14-orig/bfd/bfdio.c binutils-2.14/bfd/bfdio.c
--- binutils-2.14-orig/bfd/bfdio.c	2002-11-18 17:37:52.000000000 +0100
+++ binutils-2.14/bfd/bfdio.c	2003-12-02 17:43:31.000000000 +0100
@@ -325,7 +325,32 @@
   if (direction == SEEK_SET && abfd->my_archive != NULL)
     file_position += abfd->origin;
 
+#ifndef __amigaos__
   result = fseek (f, file_position, direction);
+#else
+  {
+    struct stat stat_buf;
+    if (direction == SEEK_CUR)
+      file_position += ftell (f);
+    fflush (f);
+    if (!(result = fstat (fileno (f), &stat_buf)) &&
+	file_position > stat_buf.st_size &&
+	!(result = fseek (f, stat_buf.st_size, SEEK_SET))) {
+      int zeroes = file_position - stat_buf.st_size;
+      char *buf = calloc (4096, 1);
+      if (buf) {
+	while (zeroes > 0) {
+	  int r, x = (zeroes > 4096? 4096 : zeroes);
+	  if ((r = write (fileno (f), buf, x))<=0)
+	    break;
+	  zeroes -= r;
+	}
+	free (buf);
+      }
+    }
+    result = fseek (f, file_position, SEEK_SET);
+  }
+#endif
   if (result != 0)
     {
       int hold_errno = errno;
diff -urNEBb binutils-2.14-orig/bfd/config.bfd binutils-2.14/bfd/config.bfd
--- binutils-2.14-orig/bfd/config.bfd	2003-06-02 21:35:20.000000000 +0200
+++ binutils-2.14/bfd/config.bfd	2003-12-02 14:09:39.000000000 +0100
@@ -38,7 +38,7 @@
 c54x*)	         targ_archs=bfd_tic54x_arch ;;
 dlx*)		 targ_archs=bfd_dlx_arch ;;
 hppa*)	         targ_archs=bfd_hppa_arch ;;
-i[3456]86)       targ_archs=bfd_i386_arch ;;
+i[3456]86*)      targ_archs=bfd_i386_arch ;;
 i370)            targ_archs=bfd_i370_arch ;;
 m6811*|m68hc11*) targ_archs="bfd_m68hc11_arch bfd_m68hc12_arch" ;;
 m6812*|m68hc12*) targ_archs="bfd_m68hc12_arch bfd_m68hc11_arch" ;;
@@ -543,6 +543,11 @@
     targ_selfvecs=i386chaos_vec
     ;;
 
+  i[3456]86be-*-amithlon*)
+    targ_defvec=bfd_elf32_i386be_amithlon_vec
+    targ_selvecs="bfd_elf32_i386_vec bfd_elf32_i386be_amithlon_vec"
+    ;;
+
   i860-*-mach3* | i860-*-osf1* | i860-*-coff*)
     targ_defvec=i860coff_vec
     ;;
@@ -605,6 +610,10 @@
   m68*-motorola-sysv*)
     targ_defvec=m68ksysvcoff_vec
     ;;
+  m68*-*-amigaos*)
+    targ_defvec=amiga_vec
+    targ_selvecs="aout_amiga_vec amiga_vec"
+    ;;
   m68*-hp-bsd*)
     targ_defvec=hp300bsd_vec
     targ_underscore=yes
@@ -684,7 +693,7 @@
     targ_selvecs="m68kcoff_vec versados_vec tekhex_vec"
     targ_underscore=yes
     ;;
-  m68*-cbm-*)
+  m68*-cbm-amix)
     targ_defvec=bfd_elf32_m68k_vec
     targ_selvecs=m68kcoff_vec
     ;;
@@ -892,6 +901,18 @@
 	targ_cflags=-DSMALL_ARCHIVE;;
     esac
     ;;
+  powerpc-*-amigaoshunk*)
+    targ_defvec=amiga_vec
+    targ_selvecs="bfd_elf32_powerpc_vec bfd_elf32_powerpcle_vec aout_amiga_vec"
+    ;;
+  powerpc-*-amigaos*)
+    targ_defvec=bfd_elf32_powerpc_vec
+    targ_selvecs="bfd_elf32_powerpcle_vec"
+    ;;
+  powerpc-*-morphos*)
+    targ_defvec=bfd_elf32_morphos_vec
+    targ_selvecs="bfd_elf32_morphos_vec"
+    ;;
 #ifdef BFD64
   powerpc64-*-aix*)
     targ_defvec=rs6000coff64_vec
@@ -907,6 +928,10 @@
     targ_selvecs="bfd_elf64_powerpc_vec bfd_elf32_powerpcle_vec bfd_elf32_powerpc_vec rs6000coff_vec rs6000coff64_vec"
     ;;
 #endif
+  powerpc-*-amiga*)
+    targ_defvec=bfd_elf32_amiga_vec
+    targ_selvecs="rs6000coff_vec bfd_elf32_powerpc_vec bfd_elf32_powerpcle_vec ppcboot_vec"
+    ;;
   powerpc-*-*bsd* | powerpc-*-elf* | powerpc-*-sysv4* | powerpc-*-eabi* | \
   powerpc-*-solaris2* | powerpc-*-linux-gnu* | powerpc-*-rtems* | \
   powerpc-*-chorus* | powerpc-*-vxworks* | powerpc-*-windiss*)
diff -urNEBb binutils-2.14-orig/bfd/configure.host binutils-2.14/bfd/configure.host
--- binutils-2.14-orig/bfd/configure.host	2002-12-17 05:17:20.000000000 +0100
+++ binutils-2.14/bfd/configure.host	2003-12-02 14:09:38.000000000 +0100
@@ -59,6 +59,7 @@
 mips*-*-riscos*)	HDEFINES="-G 4" ;;
 
 m68*-hp-hpux*)		HDEFINES=-DHOST_HP300HPUX ;;
+m68*-*-amigaos*)	HDEFINES=-mstackextend ;;
 
 *-*-aix*)		HOST_64BIT_TYPE="long long"
 			HOST_U_64BIT_TYPE="unsigned long long"
diff -urNEBb binutils-2.14-orig/bfd/configure.in binutils-2.14/bfd/configure.in
--- binutils-2.14-orig/bfd/configure.in	2003-06-12 15:25:46.000000000 +0200
+++ binutils-2.14/bfd/configure.in	2003-12-15 12:05:14.000000000 +0100
@@ -18,7 +18,7 @@
 bfd_version_string="\"${VERSION}\""
 if test x${is_release} = x; then
   bfd_version_date=`sed -n -e 's/.*DATE //p' < ${srcdir}/version.h`
-  bfd_version_string="\"${VERSION} ${bfd_version_date}\""
+  bfd_version_string="\"${VERSION} ${bfd_version_date} (Amiga, Inc. build 20031201)\""
 fi
 AC_SUBST(bfd_version)
 AC_SUBST(bfd_version_string)
@@ -544,8 +544,10 @@
     # use one entry per line, even though this leads to long lines.
     a29kcoff_big_vec)		tb="$tb coff-a29k.lo cofflink.lo" ;;
     a_out_adobe_vec)		tb="$tb aout-adobe.lo aout32.lo" ;;
+    amiga_vec)                  tb="$tb amigaos.lo amigaoslink.lo" ;;
     aix5coff64_vec)		tb="$tb coff64-rs6000.lo xcofflink.lo aix5ppc-core.lo"; target_size=64 ;;
     aout0_big_vec)		tb="$tb aout0.lo aout32.lo" ;;
+    aout_amiga_vec)		tb="$tb aout-amiga.lo aout32.lo";;
     aout_arm_big_vec)		tb="$tb aout-arm.lo aout32.lo" ;;
     aout_arm_little_vec)	tb="$tb aout-arm.lo aout32.lo" ;;
     aout_mips_big_vec)		tb="$tb mipsbsd.lo aout32.lo" ;;
@@ -566,6 +568,7 @@
     b_out_vec_little_host)	tb="$tb bout.lo aout32.lo" ;;
     bfd_efi_app_ia32_vec)	tb="$tb efi-app-ia32.lo peigen.lo cofflink.lo" ;;
     bfd_efi_app_ia64_vec)	tb="$tb efi-app-ia64.lo pepigen.lo cofflink.lo"; target_size=64 ;;
+    bfd_elf32_amiga_vec)	tb="$tb elf32-amiga.lo elf32.lo $elf" ;;
     bfd_elf32_avr_vec)		tb="$tb elf32-avr.lo elf32.lo $elf" ;;
     bfd_elf32_big_generic_vec) 	tb="$tb elf32-gen.lo elf32.lo $elf" ;;
     bfd_elf32_bigarc_vec)	tb="$tb elf32-arc.lo elf32.lo $elf" ;;
@@ -584,6 +587,7 @@
     bfd_elf32_i370_vec)		tb="$tb elf32-i370.lo elf32.lo $elf" ;;
     bfd_elf32_i386_freebsd_vec)	tb="$tb elf32-i386.lo elf32.lo $elf" ;;
     bfd_elf32_i386_vec)		tb="$tb elf32-i386.lo elf32.lo $elf" ;;
+    bfd_elf32_i386be_amithlon_vec) tb="$tb elf32-i386-amithlon.lo elf32.lo $elf" ;;
     bfd_elf32_i860_little_vec)	tb="$tb elf32-i860.lo elf32.lo $elf" ;;
     bfd_elf32_i860_vec)		tb="$tb elf32-i860.lo elf32.lo $elf" ;;
     bfd_elf32_i960_vec)		tb="$tb elf32-i960.lo elf32.lo $elf" ;;
@@ -605,6 +609,7 @@
     bfd_elf32_mcore_little_vec)	tb="$tb elf32-mcore.lo elf32.lo $elf" ;;
     bfd_elf32_mn10200_vec)	tb="$tb elf-m10200.lo elf32.lo $elf" ;;
     bfd_elf32_mn10300_vec)	tb="$tb elf-m10300.lo elf32.lo $elf" ;;
+    bfd_elf32_morphos_vec)      tb="$tb elf32-morphos.lo elf32.lo $elf";;
     bfd_elf32_msp430_vec)	tb="$tb elf32-msp430.lo elf32.lo $elf" ;;
     bfd_elf32_nbigmips_vec)	tb="$tb elfn32-mips.lo elfxx-mips.lo elf32.lo $elf ecofflink.lo"; target_size=64 ;;
     bfd_elf32_nlittlemips_vec)	tb="$tb elfn32-mips.lo elfxx-mips.lo elf32.lo $elf ecofflink.lo"; target_size=64 ;;
diff -urNEBb binutils-2.14-orig/bfd/doc/Makefile.am binutils-2.14/bfd/doc/Makefile.am
--- binutils-2.14-orig/bfd/doc/Makefile.am	2002-11-18 17:37:54.000000000 +0100
+++ binutils-2.14/bfd/doc/Makefile.am	2003-12-02 14:09:39.000000000 +0100
@@ -2,7 +2,7 @@
 
 AUTOMAKE_OPTIONS = cygnus
 
-DOCFILES = aoutx.texi  archive.texi archures.texi \
+DOCFILES = amiga.texi amigalink.texi aoutx.texi  archive.texi archures.texi \
 	bfdt.texi  cache.texi coffcode.texi \
 	core.texi elf.texi elfcode.texi  format.texi \
 	libbfd.texi bfdwin.texi bfdio.texi \
@@ -28,6 +28,7 @@
 	$(srcdir)/../cache.c $(srcdir)/../coffcode.h \
 	$(srcdir)/../corefile.c $(srcdir)/../elf.c \
 	$(srcdir)/../elfcode.h  $(srcdir)/../format.c \
+	$(srcdir)/../amigaos.c $(srcdir)/../amigaoslink.c \
 	$(srcdir)/../libbfd.c $(srcdir)/../opncls.c \
 	$(srcdir)/../reloc.c  $(srcdir)/../section.c \
 	$(srcdir)/../syms.c  $(srcdir)/../targets.c \
@@ -55,14 +56,15 @@
 MKDOC = chew$(EXEEXT_FOR_BUILD)
 
 $(MKDOC): chew.o
-	$(CC_FOR_BUILD) -o $(MKDOC) chew.o $(LOADLIBES) $(LDFLAGS)
+	$(CC_FOR_BUILD) $(H_CFLAGS) $(CFLAGS) -o $(MKDOC) chew.o $(LOADLIBES) $(LDFLAGS)
 
 chew.o: chew.c
 	$(CC_FOR_BUILD) -c -I.. -I$(srcdir)/.. -I$(srcdir)/../../include -I$(srcdir)/../../intl -I../../intl $(H_CFLAGS) $(CFLAGS) $(srcdir)/chew.c
 
 protos: libbfd.h libcoff.h bfd.h
 
-bfd.info bfd.dvi: $(DOCFILES) bfdsumm.texi bfd.texinfo
+bfd.info bfd.dvi bfd.guide: $(DOCFILES) bfdsumm.texi bfd.texinfo
+
 
 # We can't replace these rules with an implicit rule, because
 # makes without VPATH support couldn't find the .h files in `..'.
@@ -208,6 +210,18 @@
 	touch s-linker
 linker.texi: s-linker
 
+s-amiga: $(MKDOC) $(srcdir)/../amigaos.c $(srcdir)/doc.str
+	./$(MKDOC) -f $(srcdir)/doc.str <$(srcdir)/../amigaos.c >amiga.tmp
+	$(srcdir)/../../move-if-change amiga.tmp amiga.texi
+	touch s-amiga
+amiga.texi: s-amiga
+
+s-amigalink: $(MKDOC) $(srcdir)/../amigaoslink.c $(srcdir)/doc.str
+	./$(MKDOC) -f $(srcdir)/doc.str <$(srcdir)/../amigaoslink.c >amigalink.tmp
+	$(srcdir)/../../move-if-change amigalink.tmp amigalink.texi
+	touch s-amigalink
+amigalink.texi: s-amigalink
+
 LIBBFD_H_DEP = \
 	$(srcdir)/../libbfd-in.h	\
 	$(srcdir)/../init.c		\
@@ -304,4 +318,4 @@
 
 # We want install to imply install-info as per GNU standards, despite the
 # cygnus option.
-install: install-info
+#install: install-info
diff -urNEBb binutils-2.14-orig/bfd/doc/bfd.texinfo binutils-2.14/bfd/doc/bfd.texinfo
--- binutils-2.14-orig/bfd/doc/bfd.texinfo	2003-02-13 12:26:40.000000000 +0100
+++ binutils-2.14/bfd/doc/bfd.texinfo	2003-12-02 14:09:39.000000000 +0100
@@ -299,6 +299,7 @@
 * aout ::	a.out backends
 * coff ::	coff backends
 * elf  ::	elf backends
+* amiga ::      amigaos backend
 * mmo  ::	mmo backend
 @ignore
 * oasys ::	oasys backends
@@ -315,12 +316,16 @@
 @node coff, elf, aout, BFD back ends
 @include  coffcode.texi
 
-@node elf, mmo, coff, BFD back ends
+@node elf, amiga, coff, BFD back ends
 @include  elf.texi
 @c Leave this out until the file has some actual contents...
 @c @include  elfcode.texi
 
-@node mmo,  , elf, BFD back ends
+@node amiga, mmo, elf, BFD back ends
+@include amiga.texi
+@include amigalink.texi
+
+@node mmo, , amiga, BFD back ends
 @include  mmo.texi
 
 @node GNU Free Documentation License, Index, BFD back ends, Top
diff -urNEBb binutils-2.14-orig/bfd/elf32-i386-amithlon.c binutils-2.14/bfd/elf32-i386-amithlon.c
--- binutils-2.14-orig/bfd/elf32-i386-amithlon.c	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/bfd/elf32-i386-amithlon.c	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,198 @@
+/* Intel IA-32 specific support for 32-bit big endian ELF on Amithlon.
+   Copyright 2002 Free Software Foundation, Inc.
+   Written by Martin Blom.
+
+This file is part of BFD, the Binary File Descriptor library.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#define TARGET_LITTLE_SYM		bfd_elf32_i386_amithlon_vec
+#define TARGET_LITTLE_NAME		"elf32-i386-amithlon"
+#define TARGET_BIG_SYM			bfd_elf32_i386be_amithlon_vec
+#define TARGET_BIG_NAME			"elf32-i386be-amithlon"
+#define ELF_ARCH			bfd_arch_i386
+#define ELF_MACHINE_CODE		EM_386
+#define ELF_MAXPAGESIZE			32  //0x1000
+
+#include "bfd.h"
+#include "sysdep.h"
+#include "elf-bfd.h"
+
+/* Forward declarations */
+extern const bfd_target bfd_elf32_i386_amithlon_vec;
+extern const bfd_target bfd_elf32_i386be_amithlon_vec;
+
+static boolean elf_i386_relocate_section
+  PARAMS ((bfd *, struct bfd_link_info *, bfd *, asection *, bfd_byte *,
+	   Elf_Internal_Rela *, Elf_Internal_Sym *, asection **));
+
+static boolean elf_i386_finish_dynamic_sections
+  PARAMS ((bfd *, struct bfd_link_info *));
+
+static boolean elf_i386_finish_dynamic_symbol
+  PARAMS ((bfd *, struct bfd_link_info *, struct elf_link_hash_entry *,
+	   Elf_Internal_Sym *));
+
+boolean elf_link_output_relocs
+  PARAMS ((bfd *, asection *, Elf_Internal_Shdr *, Elf_Internal_Rela *));
+
+#define swap_xvec(xvec,c)                                   \
+do {                                                        \
+  xvec->bfd_getx64         = bfd_get ## c ## 64;            \
+  xvec->bfd_getx_signed_64 = bfd_get ## c ## _signed_64;    \
+  xvec->bfd_putx64         = bfd_put ## c ## 64;            \
+  xvec->bfd_getx32         = bfd_get ## c ## 32;            \
+  xvec->bfd_getx_signed_32 = bfd_get ## c ## _signed_32;    \
+  xvec->bfd_putx32         = bfd_put ## c ## 32;            \
+  xvec->bfd_getx16         = bfd_get ## c ## 16;            \
+  xvec->bfd_getx_signed_16 = bfd_get ## c ## _signed_16;    \
+  xvec->bfd_putx16         = bfd_put ## c ## 16;            \
+} while(0)
+
+/* Relocate a big endian i386 ELF section.  */
+
+static boolean
+amithlon_relocate_section (output_bfd, info, input_bfd, input_section,
+			   contents, relocs, local_syms, local_sections)
+     bfd *output_bfd;
+     struct bfd_link_info *info;
+     bfd *input_bfd;
+     asection *input_section;
+     bfd_byte *contents;
+     Elf_Internal_Rela *relocs;
+     Elf_Internal_Sym *local_syms;
+     asection **local_sections;
+{
+  boolean switched_input  = false;
+  boolean switched_output = false;
+  boolean rc;
+
+  /* Since code sections are actually little endian, no matter what
+     endian mode we're operating in, this rather dirty hack is used to
+     make sure the correct data access routines are used. */
+
+  if ((bfd_get_section_flags (input_bfd, input_section) & SEC_CODE))
+  {
+    if (input_bfd->xvec == &bfd_elf32_i386be_amithlon_vec)
+    {
+      switched_input = true;
+
+      swap_xvec(input_bfd->xvec,l);
+    }
+    
+    if (output_bfd->xvec == &bfd_elf32_i386be_amithlon_vec)
+    {
+      switched_output = true;
+
+      swap_xvec(output_bfd->xvec,l);
+    }
+  }
+
+  rc = elf_i386_relocate_section (output_bfd, info, input_bfd, input_section,
+				  contents, relocs,
+				  local_syms, local_sections);
+  
+  if (switched_input)
+  {
+    swap_xvec(input_bfd->xvec,b);
+  }
+
+  if (switched_output)
+  {
+    swap_xvec(output_bfd->xvec,b);
+  }
+  
+  return rc;
+}  
+
+static boolean
+amithlon_finish_dynamic_sections (output_bfd, info)
+     bfd *output_bfd;
+     struct bfd_link_info *info;
+{
+  boolean switched_output = false;
+  boolean rc;
+
+  /* Since code sections are actually little endian, no matter what
+     endian mode we're operating in, this rather dirty hack is used to
+     make sure the correct data access routines are used. */
+
+  if (output_bfd->xvec == &bfd_elf32_i386be_amithlon_vec)
+  {
+    switched_output = true;
+
+    swap_xvec(output_bfd->xvec,l);
+  }
+
+  rc = elf_i386_finish_dynamic_sections (output_bfd, info);
+
+  if (switched_output)
+  {
+    swap_xvec(output_bfd->xvec,b);
+  }
+  
+  return rc;
+}
+
+static boolean
+amithlon_finish_dynamic_symbol (output_bfd, info, h, sym)
+     bfd *output_bfd;
+     struct bfd_link_info *info;
+     struct elf_link_hash_entry *h;
+     Elf_Internal_Sym *sym;
+{
+  boolean switched_output = false;
+  boolean rc;
+
+  /* Since code sections are actually little endian, no matter what
+     endian mode we're operating in, this rather dirty hack is used to
+     make sure the correct data access routines are used. */
+
+  if (output_bfd->xvec == &bfd_elf32_i386be_amithlon_vec)
+  {
+    switched_output = true;
+
+    swap_xvec(output_bfd->xvec,l);
+  }
+
+  rc = elf_i386_finish_dynamic_symbol (output_bfd, info, h, sym);
+
+  if (switched_output)
+  {
+    swap_xvec(output_bfd->xvec,b);
+  }
+  
+  return rc;
+}
+
+static bfd_size_type
+amithlon_additional_program_headers (abfd)
+     bfd *abfd;
+{
+//  printf("big: %x little: %x\n",
+//	 &bfd_elf32_i386be_amithlon_vec,
+//	 &bfd_elf32_i386_amithlon_vec);
+  // headers, text, rodata, data+bss
+  return -2+4;
+}
+
+#define elf_backend_relocate_section	        amithlon_relocate_section
+#define elf_backend_finish_dynamic_sections     amithlon_finish_dynamic_sections
+#define elf_backend_finish_dynamic_symbol       amithlon_finish_dynamic_symbol
+#define elf_backend_additional_program_headers  amithlon_additional_program_headers
+
+#define ELF32_I386_RELOCATABLE_EXECUTABLES 1
+
+#include "elf32-i386.c"
diff -urNEBb binutils-2.14-orig/bfd/elf32-i386.c binutils-2.14/bfd/elf32-i386.c
--- binutils-2.14-orig/bfd/elf32-i386.c	2003-05-02 18:06:14.000000000 +0200
+++ binutils-2.14/bfd/elf32-i386.c	2003-12-02 14:09:39.000000000 +0100
@@ -24,6 +24,10 @@
 #include "libbfd.h"
 #include "elf-bfd.h"
 
+#ifndef ELF32_I386_RELOCATABLE_EXECUTABLES
+#define ELF32_I386_RELOCATABLE_EXECUTABLES 0
+#endif
+
 static reloc_howto_type *elf_i386_reloc_type_lookup
   PARAMS ((bfd *, bfd_reloc_code_real_type));
 static void elf_i386_info_to_howto_rel
@@ -1105,7 +1109,7 @@
 	     may need to keep relocations for symbols satisfied by a
 	     dynamic library if we manage to avoid copy relocs for the
 	     symbol.  */
-	  if ((info->shared
+	  if (((ELF32_I386_RELOCATABLE_EXECUTABLES || info->shared)
 	       && (sec->flags & SEC_ALLOC) != 0
 	       && (r_type != R_386_PC32
 		   || (h != NULL
@@ -1673,7 +1677,7 @@
      space for pc-relative relocs that have become local due to symbol
      visibility changes.  */
 
-  if (info->shared)
+  if (ELF32_I386_RELOCATABLE_EXECUTABLES || info->shared)
     {
       if ((h->elf_link_hash_flags & ELF_LINK_HASH_DEF_REGULAR) != 0
 	  && ((h->elf_link_hash_flags & ELF_LINK_FORCED_LOCAL) != 0
@@ -2421,7 +2425,7 @@
 	      || (input_section->flags & SEC_ALLOC) == 0)
 	    break;
 
-	  if ((info->shared
+	  if (((ELF32_I386_RELOCATABLE_EXECUTABLES || info->shared)
 	       && (r_type != R_386_PC32
 		   || (h != NULL
 		       && h->dynindx != -1
@@ -2466,6 +2470,7 @@
 		memset (&outrel, 0, sizeof outrel);
 	      else if (h != NULL
 		       && h->dynindx != -1
+		       && !(ELF32_I386_RELOCATABLE_EXECUTABLES && !info->shared)
 		       && (r_type == R_386_PC32
 			   || !info->shared
 			   || !info->symbolic
@@ -3384,14 +3389,20 @@
 #define elf_backend_copy_indirect_symbol      elf_i386_copy_indirect_symbol
 #define elf_backend_create_dynamic_sections   elf_i386_create_dynamic_sections
 #define elf_backend_fake_sections	      elf_i386_fake_sections
+#ifndef elf_backend_finish_dynamic_sections
 #define elf_backend_finish_dynamic_sections   elf_i386_finish_dynamic_sections
+#endif
+#ifndef elf_backend_finish_dynamic_symbol
 #define elf_backend_finish_dynamic_symbol     elf_i386_finish_dynamic_symbol
+#endif
 #define elf_backend_gc_mark_hook	      elf_i386_gc_mark_hook
 #define elf_backend_gc_sweep_hook	      elf_i386_gc_sweep_hook
 #define elf_backend_grok_prstatus	      elf_i386_grok_prstatus
 #define elf_backend_grok_psinfo		      elf_i386_grok_psinfo
 #define elf_backend_reloc_type_class	      elf_i386_reloc_type_class
+#ifndef elf_backend_relocate_section
 #define elf_backend_relocate_section	      elf_i386_relocate_section
+#endif
 #define elf_backend_size_dynamic_sections     elf_i386_size_dynamic_sections
 
 #include "elf32-target.h"
diff -urNEBb binutils-2.14-orig/bfd/hosts/amigaos.h binutils-2.14/bfd/hosts/amigaos.h
--- binutils-2.14-orig/bfd/hosts/amigaos.h	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/bfd/hosts/amigaos.h	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,5 @@
+/* Host configuration for AmigaOS */
+#ifndef hosts_amigaos_h
+#define hosts_amigaos_h
+#include "hosts/std-host.h"
+#endif /* hosts_amigaos_h */
diff -urNEBb binutils-2.14-orig/bfd/hosts/morphos.h binutils-2.14/bfd/hosts/morphos.h
--- binutils-2.14-orig/bfd/hosts/morphos.h	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/bfd/hosts/morphos.h	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,5 @@
+/* Host configuration for MorphOS */
+#ifndef hosts_morphos_h
+#define hosts_morphos_h
+#include "hosts/std-host.h"
+#endif /* hosts_morphos_h */
